> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Send Discovery Email

> Send a discovery Email Magic Link using the Stytch B2B API

export const member = "Represents an individual end user's account within a given Organization, uniquely identified within that Organization by their email address.";

Send a discovery Email Magic Link to a <Tooltip tip={member}>Member</Tooltip>.

The magic link is valid and can be [authenticated](/api-reference/b2b/api/email-magic-links/discovery/authenticate-discovery-magic-link) for 60 minutes, after which the Member will need to request a new magic link.


## OpenAPI

````yaml POST /v1/b2b/magic_links/email/discovery/send
openapi: 3.0.3
info:
  title: Stytch API
  description: The Stytch API provides endpoints for authentication and user management.
  version: 2.0.0
  contact:
    name: Stytch Support
    url: https://stytch.com/docs
    email: support@stytch.com
servers:
  - url: https://api.stytch.com
    description: Production server
  - url: https://test.stytch.com
    description: Test server
security:
  - basicAuth: []
paths:
  /v1/b2b/magic_links/email/discovery/send:
    post:
      tags:
        - Email
      summary: Send
      description: >-
        Send a discovery magic link to an email address. The magic link is valid
        for 60 minutes.
      operationId: api_b2b_magic_v1_b2b_magic_links_email_discovery_Send
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/api_b2b_magic_v1_b2b_magic_links_email_discovery_SendRequest
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api_b2b_magic_v1_b2b_magic_links_email_discovery_SendResponse
        '400':
          description: Bad request
        '401':
          description: Unauthorized
          content:
            application/json:
              example:
                status_code: 401
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: unauthorized_credentials
                error_message: Unauthorized credentials.
                error_url: https://stytch.com/docs/api/errors/401
        '429':
          description: Too Many Requests
          content:
            application/json:
              example:
                status_code: 429
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: too_many_requests
                error_message: Too many requests have been made.
                error_url: https://stytch.com/docs/api/errors/429
        '500':
          description: Internal server error
          content:
            application/json:
              example:
                status_code: 500
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: internal_server_error
                error_message: >-
                  Oops, something seems to have gone wrong, please reach out to
                  support@stytch.com to let us know what went wrong.
                error_url: https://stytch.com/docs/api/errors/500
      x-code-samples:
        - lang: csharp
          label: C#
          source: |-
            // POST /v1/b2b/magic_links/email/discovery/send
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              email_address: "${email}",
            };

            client.MagicLinks.Email.Discovery.Send(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: go
          label: Go
          source: "// POST /v1/b2b/magic_links/email/discovery/send\npackage main\n\nimport (\n\t\"context\"\n\t\"log\"\n\n\t\"github.com/stytchauth/stytch-go/v17/stytch/b2b/b2bstytchapi\"\n\t\"github.com/stytchauth/stytch-go/v17/stytch/b2b/magiclinks/email/discovery\"\n)\n\nfunc main() {\n\tclient, err := b2bstytchapi.NewClient(\n\t\t\"${projectId}\",\n\t\t\"${secret}\",\n\t)\n\tif err != nil {\n\t\tlog.Fatalf(\"error instantiating client: %v\", err)\n\t}\n\n\tparams := &discovery.SendParams{\n\t\tEmailAddress: \"${email}\",\n\t}\n\n\tresp, err := client.MagicLinks.Email.Discovery.Send(context.Background(), params)\n\tif err != nil {\n\t\tlog.Fatalf(\"error in method call: %v\", err)\n\t}\n\n\tlog.Println(resp)\n}\n"
        - lang: java
          label: Java
          source: >-
            // POST /v1/b2b/magic_links/email/discovery/send

            package com.example;


            import
            com.stytch.java.b2b.models.magiclinksemaildiscovery.SendRequest;

            import com.stytch.java.b2b.StytchB2BClient;

            import com.stytch.java.common.StytchResult;


            public class Main {
                public static void main(String[] args) {
                    StytchB2BClient.configure("${projectId}", "${secret}");

                    SendRequest params = new SendRequest();
                    params.setEmailAddress("${email}");

                    Object result = StytchB2BClient.getMagicLinks().getEmail().getDiscovery().send(params);
                    if (result instanceof StytchResult.Success) {
                      System.out.println(((StytchResult.Success) result).getValue());
                    } else {
                      System.out.println(((StytchResult.Error) result).getException());
                    }
                }
            }
        - lang: kotlin
          label: Kotlin
          source: >
            // POST /v1/b2b/magic_links/email/discovery/send

            package com.example


            import com.stytch.java.b2b.StytchB2BClient

            import
            com.stytch.java.b2b.models.magiclinksemaildiscovery.SendRequest


            fun main() {
                StytchB2BClient.configure(
                    projectId = "${projectId}",
                    secret = "${secret}",
                )

                when (
                    val result =
                        StytchB2BClient.magicLinks.email.discovery.send(
                            SendRequest(
                                emailAddress = "${email}",
                            ),
                        )
                ) {
                    is StytchResult.Success -> println(result.value)
                    is StytchResult.Error -> println(result.exception)
                }
            }
        - lang: javascript
          label: Node.js
          source: |-
            // POST /v1/b2b/magic_links/email/discovery/send
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              email_address: "${email}",
            };

            client.magicLinks.email.discovery.send(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: php
          label: PHP
          source: |-
            $response = $client->magic_links->email->discovery->send([
                'email_address' => '${email}',
            ]);
        - lang: python
          label: Python
          source: |
            # POST /v1/b2b/magic_links/email/discovery/send
            from stytch import B2BClient

            client = B2BClient(
                project_id="${projectId}",
                secret="${secret}",
            )

            resp = client.magic_links.email.discovery.send(
                email_address="${email}",
            )

            print(resp)
        - lang: ruby
          label: Ruby
          source: |-
            # POST /v1/b2b/magic_links/email/discovery/send
            require 'stytch'

            client = StytchB2B::Client.new(
              project_id: "${projectId}",
              secret: "${secret}"
            )

            resp = client.magic_links.email.discovery.send(
              email_address: "${email}"
              
            )

            puts resp
        - lang: rust
          label: Rust
          source: |-
            // POST /v1/b2b/magic_links/email/discovery/send
            use stytch::b2b::client::Client;
            use stytch::b2b::magic_links_email_discovery::SendRequest;

            fn main() {
                let client = Client::new("${projectId}", "${secret}").unwrap();
                let resp = client.magic_links.email.discovery.send(
                    SendRequest{
                        email_address: "${email}",
                        ..Default::default()
                    }
                ).await;
                println!("The response is {:?}", resp);
            }
        - lang: bash
          label: cURL
          source: |-
            # POST /v1/b2b/magic_links/email/discovery/send
            curl --request POST \
              --url https://test.stytch.com/v1/b2b/magic_links/email/discovery/send \
              -u '${projectId}:${secret}' \
              -H 'Content-Type: application/json' \
              -d '{
                "email_address": "${email}"
              }'
components:
  schemas:
    api_b2b_magic_v1_b2b_magic_links_email_discovery_SendRequest:
      type: object
      properties:
        email_address:
          type: string
          description: The email address of the Member.
        discovery_redirect_url:
          type: string
          description: >-
            The URL that the end user clicks from the discovery Magic Link. This
            URL should be an endpoint in the backend server that
              verifies the request by querying Stytch's discovery authenticate endpoint and continues the flow. If this value is not passed, the default
              discovery redirect URL that you set in your Dashboard is used. If you have not set a default discovery redirect URL, an error is returned.
        pkce_code_challenge:
          type: string
          description: >-
            A base64url encoded SHA256 hash of a one time secret used to
            validate that the request starts and ends on the same device.
        login_template_id:
          type: string
          description: >-
            Use a custom template for discovery emails. By default, it will use
            your default email template. Templates can be added in the [Stytch
            dashboard](https://stytch.com/dashboard/templates) using our
            built-in customization options or custom HTML templates with type
            “Magic Links - Login”.
        locale:
          $ref: '#/components/schemas/api_b2b_magic_v1_SendRequestLocale'
          description: >
            Used to determine which language to use when sending the user this
            delivery method. Parameter is an [IETF BCP 47 language
            tag](https://www.w3.org/International/articles/language-tags/), e.g.
            `"en"`.


            Currently supported languages are English (`"en"`), Spanish
            (`"es"`), French (`"fr"`) and Brazilian Portuguese (`"pt-br"`); if
            no value is provided, the copy defaults to English.


            Request support for additional languages
            [here](https://docs.google.com/forms/d/e/1FAIpQLScZSpAu_m2AmLXRT3F3kap-s_mcV6UTBitYn6CdyWP0-o7YjQ/viewform?usp=sf_link")!
        discovery_expiration_minutes:
          type: integer
          format: int32
          minimum: 0
          description: >-
            The expiration time, in minutes, for an discovery magic link email.
            If not accepted within this time frame, the email will need to be
            resent. Defaults to 60 (1 hour) with a minimum of 5 and a maximum of
            10080 (1 week).
      description: Request type
      required:
        - email_address
    api_b2b_magic_v1_b2b_magic_links_email_discovery_SendResponse:
      type: object
      properties:
        request_id:
          type: string
          description: >-
            Globally unique UUID that is returned with every API call. This
            value is important to log for debugging purposes; we may ask for
            this value to help identify a specific API call when helping you
            debug an issue.
        status_code:
          type: integer
          format: int32
          description: >-
            The HTTP status code of the response. Stytch follows standard HTTP
            response status code patterns, e.g. 2XX values equate to success,
            3XX values are redirects, 4XX are client errors, and 5XX are server
            errors.
      required:
        - request_id
        - status_code
    api_b2b_magic_v1_SendRequestLocale:
      type: string
      enum:
        - en
        - es
        - pt-br
        - fr
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````